//////////////////////////////////////////////////////////////////////////
//                                                                      //
//                                                                      //
//   TEST_LANGUAGES.PRG
//                                                                      //
//   06-02-2024                                                         //
//                                                                      //
//   www.cobasystems.com --- COBA Systems --- Slobodan Stanojevi Coba  //
//   Open Source Project BAST Business Account Software Technology      //
//   www.Alaska-Software.com --- Alaska Xbase++ version 2.0.1503        //
//   www.Donnay-software.com --- eXpress++      version 2.0.268         //
//   Sergej Spirin --- FastReport for Xbase++   version 27.03.2015      //
//                                                                      //
//   Database Server PostgreSQL                 version 9.4.4.          //
//                                                                      //
//                                                                      //
//////////////////////////////////////////////////////////////////////////

* FUNCTION MAKE_LANGUAGE()
*   STATIC FUNCTION INSERT_ITEM()
*   STATIC FUNCTION DELETE_ITEM()
*   STATIC FUNCTION EDIT_LANGUAGE()
*   STATIC FUNCTION CH_file()
*   STATIC FUNCTION help_programa()

#include "Gra.ch"
#include "Xbp.ch"
#include "Font.ch"
#include "Common.ch"
#include "Appevent.ch"
#include "Appedit.ch"
#include "Appbrow.ch"

#include "Directry.ch"  // za funkciju directory()

#include "xbtsys.ch"
#include "dcdialog.ch"
#include "dcgra.ch"

#include "dll.ch"
#include "Dmlb.ch"
#include "DbfDbe.ch"

//-------------------------------------------------------------------------------
// LANGUAGES.CH
// SADRI <SYMBOLIC CONSTANTS> I NJIHOVE <RESULTS> NUMERIKE VREDNOSTI
// I ZA SVAKU APLIKACIJU JE OVAJ <LANGUAGES.CH> SA RAZLIITIM SADRAJEM.
// U NJEMU SE NE SME NITA MENJATI JER JE SVE PREKO <RESULTS> POVEZANO
// SA PODACIMA IZ FAJLA <LANGUAGES.DBF> KOJI SADRI TEKSTOVE IZ PROGRAMA
// KOJI SE MOGU PRIKAZATI U DVA JEZIKA:
//           DCLANG_ENGLISH  // engleski jezik
//           DCLANG_LOCALE   // korisnikov lokalni jezik
// TEKSTOVE ZA DCLANG_LOCALE U DBF UPISUJE I MENJA SAM KORISNIK PROGRAMA

// LANGUAGES.CH
// CONTAINS <SYMBOLIC CONSTANTS> AND THEIR <RESULTS> NUMERIC VALUES
// AND FOR EACH APPLICATION THERE IS THIS <LANGUAGES.CH> WITH DIFFERENT CONTENTS.
// NOTHING MUST BE CHANGED IN IT BECAUSE EVERYTHING IS CONNECTED THROUGH <RESULTS>
// WITH DATA FROM THE FILE <LANGUAGES.DBF> WHICH CONTAINS THE TEXTS FROM THE PROGRAM
// WHICH CAN BE DISPLAYED IN TWO LANGUAGES:
//           DCLANG_ENGLISH // English language
//           DCLANG_LOCALE // user's local language
// TEXTS FOR DCLANG_LOCALE IN DBF ARE WRITE AND CHANGED BY THE USER OF THE PROGRAM
//---------------------------------------------------------------------------------
#include "LANGUAGES.CH"



PROCEDURE AppSys()
// Desktop remains application window
RETURN

/*
* If you are working with a PostgreSQL database, then this procedure must be activated:
* Ako se radi sa PostgreSQL bazom podataka tada se mora aktivirati ova procedura:
PROCEDURE DbeSys()

// Overload the default DBESYS for your required DBE
   IF ! DbeLoad( "DBFDBE", .T.)     // load engine for DBF files
      msgbox( "Database Engine DBFDBE not loaded" , "STOP" )
      QUIT
   ENDIF
   IF ! DbeLoad( "NTXDBE", .T.)     // load engine for DBF files
      msgbox( "Database Engine NTXDBE not loaded" , "STOP" )
      QUIT
   ENDIF
   DbeBuild( "DBFNTX", "DBFDBE", "NTXDBE" )   // DBE=DBFNTX
   DbeSetDefault("DBFNTX")

   DbeLoad("PGDBE")
   DbeSetDefault("PGDBE")

RETURN
*/


PROCEDURE Main()
SET DATE GERMAN
SET CENTURY ON
SET CHARSET TO ANSI

 ***************
 MAKE_LANGUAGE()
 ***************

RETURN

PROCEDURE AppQuit()
   CLOSE ALL
   QUIT
RETURN

FUNCTION Gde_Exe()
 cApp_Folder_Exe := STRTRAN(AppName(.T.),"\"+AppName())
RETURN( cApp_Folder_Exe )





*************************************************************************
FUNCTION MAKE_LANGUAGE()
*************************************************************************
LOCAL radno:=SELECT()
LOCAL getlist := {} ,  GetOptions, oDlg, oBrowse


* -------------------------------------------------------- LANGUAGES.INI
PUBLIC ini := gde_exe()+"\LANGUAGES.INI"
PUBLIC applanguage, snLanguage
IF FILE(ini)==.F.
   DC_INIWRITE(ini,"LANGUAGE","applanguage","LOC") // formira INI ako ga nema
ENDIF
applanguage   := DC_INIREAD(ini,"LANGUAGE","applanguage")  // ne formira INI ako ga nema
* applanguage  = "LOC" // App works with local language    // App radi sa lokalnim jezikom
* applanguage  = "ENG" // App works with English language  // App radi sa engleskim jezikom
snLanguage := applanguage
* -------------------------------------------------------- LANGUAGES.INI

************************
 LNG_SET( applanguage )   // __LANGUAGES.PRG
************************


* -------------------------------------------------------- LANGUAGES.DBF
* gde_exe() -> strtran( appname(.t.),"\"+appname() )
* DIRMAKE( gde_exe()+"\DBF")
  LNGFILE := gde_exe()+"\DBF\LANGUAGES.DBF"  // make in __LANGUAGES.PRG
* -------------------------------------------------------- LANGUAGES.DBF

   USE (LNGFILE) NEW EXCLUSIVE ALIAS "LNG" VIA "DBFNTX"
  * VIA "DBFNTX" = je obavezno kada se radi sa DbeSetDefault("PGDBE")
  * VIA "DBFNTX" = is required when working with DbeSetDefault("PGDBE")

   IF NetErr()
      MsgBox(LNGFILE+chr(13)+LNG_MSG(_NETWORK_),"Stop")
      RETURN .F.
   ENDIF

* -------------------------------------------------------- lProtect
IF FILE(gde_exe()+"\lProtect")
   lProtect := .F.
   // Operating mode - For developer only - Samo za programera
ELSE
   lProtect := .T.
   // Operating mode - For user of program - za korisnika programa
ENDIF
* -------------------------------------------------------- lProtect


RESTART:=.F.
HOR := 40
VER := 20

@ 1,1 dcbrowse oBrowse ALIAS "LNG" SIZE HOR,VER FIT // FONT "11.Consolas"

DCBROWSECOL FIELD LNG->CODE_    HEADER "RESULT CODE"              PARENT oBrowse
DCBROWSECOL FIELD LNG->MARK_    HEADER "SYMBOLIC CONSTANT"        PARENT oBrowse
DCBROWSECOL FIELD LNG->ENGLISH_ HEADER "MESSAGE ENGLISH LANGUAGE" PARENT oBrowse
DCBROWSECOL FIELD LNG->LOCALE_  HEADER "MESSAGE LOCAL LANGUAGE"   PARENT oBrowse

xx:=VER+2
PUBLIC coo1:= GRA_CLR_WHITE   // font
PUBLIC coo2:= GRA_CLR_DARKRED // background

@xx,1   dcpushbuttonxp ;
	CAPTION LNG_MSG(_ENG_)+";"+LNG_MSG(_ENGLISH_) notabstop ;
	SIZE 30,3  ;
		ACTION {|| ;
		DC_INIWRITE(ini,"LANGUAGE","applanguage","ENG") ,;
		RESTART:=.T. ,;
		DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) } ;
		COLOR {|| IIF(applanguage = "ENG", {coo1,coo2},{NIL,NIL})} //  {coo2,coo1} )  }

@xx,1+30+2 dcpushbuttonxp ;
	CAPTION LNG_MSG(_LOC_)+";"+LNG_MSG(_LOCALE_) notabstop ;
	SIZE 30,3 ;
		ACTION {|| ;
		DC_INIWRITE(ini,"LANGUAGE","applanguage","LOC") ,;
		RESTART:=.T. ,;
		DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) } ;
		COLOR {|| IIF(applanguage = "LOC", {coo1,coo2},{NIL,NIL})} // {coo2,coo1} ) }


@xx,1+30+2+30+2 dcpushbuttonxp ;
	CAPTION LNG_MSG(_EDIT_) notabstop ;
	SIZE 15,3  ;
		ACTION {|| ;
                EDIT_LANGUAGE() ,;
		dc_getrefresh(GetList),;
		oBrowse:refreshall(), setAppfocus(oBrowse) }



@xx,1+30+2+30+2+15+2 dcpushbuttonxp ;
	CAPTION "Test" notabstop ;
	SIZE 15,3  ;
		ACTION {|| ;
		MsgBox(LNG_MSG(_NOTFOUND_),"_NOTFOUND_")    ,;
		MsgBox(LNG_MSG(_WAIT_),"_WAIT_")  ,;
		oBrowse:refreshall(), setAppfocus(oBrowse) }



@xx,1+30+2+30+2+15+2+15+2 dcpushbuttonxp ;
	CAPTION "CH file" notabstop ;
	SIZE 15,3 ;
		ACTION {|| ;
                CH_file(),;
		oBrowse:refreshall(), setAppfocus(oBrowse) } WHEN {|| !lProtect }


@xx,1+30+2+30+2+15+2+15+2+15+2 dcpushbuttonxp ;
	CAPTION LNG_MSG(_NEW_) notabstop ;
	SIZE 15,3  ;
		ACTION {|| ;
                INSERT_ITEM(),;
		oBrowse:refreshall(), setAppfocus(oBrowse) }  WHEN {|| !lProtect }

@xx,1+30+2+30+2+15+2+15+2+15+2+15+2 dcpushbuttonxp ;
	CAPTION LNG_MSG(_DEL_) notabstop ;
	SIZE 15,3  ;
		ACTION {|| ;
                DELETE_ITEM(),;
		oBrowse:refreshall(), setAppfocus(oBrowse) }  WHEN {|| !lProtect }


@xx,1+30+2+30+2+15+2+15+2+15+2+15+2+15+2  dcpushbuttonxp ;
	CAPTION LNG_MSG(_HELP_) notabstop ;
	SIZE 15,3  ;
		ACTION {|| ;
                help_programa(),;
		oBrowse:refreshall(), setAppfocus(oBrowse) }


@xx,1+30+2+30+2+15+2+15+2+15+2+15+2+15+2+15+2  dcpushbuttonxp ;
	CAPTION LNG_MSG(_EXIT_) notabstop ;
	SIZE 13,3  ;
		ACTION {|| DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }



DCHOTKEY asc("+") ACTION {|| memowrit(gde_exe()+"\lProtect","DEVELOPER MOD") ,;
                             MsgBox("DEVELOPER MOD","OK") ,;
		             RESTART:=.T. ,;
		             DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }

DCHOTKEY asc("-") ACTION {|| FileDelete(gde_exe()+"\lProtect") ,;  // XBTBASE2.LIB
		             MsgBox("USER MOD","OK") ,;
		             RESTART:=.T. ,;
		             DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) } ;



DCGETOPTIONS FONT "8.Helv Bold" AUTORESIZE NOESCAPEKEY

DCREAD GUI ;
OPTIONS GetOptions ;
PARENT @oDlg ;
TITLE LNG_MSG(_APPNAME_) FIT ;
EVAL {|o| SETAPPWINDOW(o)} MODAL

SELECT "LNG";USE

IF RESTART==.T.
   MAIN()
ENDIF

RETURN NIL


* STATIC FUNCTION INSERT_ITEM()
* STATIC FUNCTION DELETE_ITEM()
* STATIC FUNCTION EDIT_LANGUAGE()
* STATIC FUNCTION CH_file()
* STATIC FUNCTION help_programa()

**************************************************************************
STATIC FUNCTION INSERT_ITEM()
**************************************************************************
* STOP("For developer only - Samo za programera",0)
LOCAL radno:=SELECT()
APPEND BLANK
nrecno := recno()
ntest  := recno()

*---------------------------------------
DO WHILE .T.

go top
locate for CODE_=ntest

if found()
   MsgBox("Found CODE_ "+var2char(ntest),"Stop")
   ntest:=ntest+1
   loop
else
   exit
endif

ENDDO
*---------------------------------------

goto nrecno
replace CODE_ with ntest, MARK_ WITH "*** NEW ITEM ***"

SELECT(radno)
RETURN NIL

**************************************************************************
STATIC FUNCTION DELETE_ITEM()
**************************************************************************
* STOP("For developer only - Samo za programera",0)
LOCAL radno:=SELECT()
skip -1
nrecno := recno() // prethodna stavka // previous item
skip

DELETE
PACK

goto nrecno
SELECT(radno)
RETURN NIL


************************************************************************
STATIC FUNCTION EDIT_LANGUAGE() // rucni upis u polja
************************************************************************

 LOCAL GetList := {}, GetOptions, oDlg, boja, xx:=0, zz:=1+0.2
 LOCAL aCUR := {"user32.dll",114}
 LOCAL oCUR := {"user32.dll",112}

 boja := { GRA_CLR_BLACK, GRA_CLR_WHITE }

// moze sa get...
   SET DATE FORMAT TO 'dd.mm.yyyy'

IF FILE(gde_exe()+"\lProtect")
   lProtect := .F.
ELSE
   lProtect := .T.
ENDIF


xx:=xx+zz
   @ xx, 1   DCSAY "RESULT CODE:"  SAYSIZE 0
   @ xx, 15  DCGET CODE_ EDITPROTECT {|| lprotect } ;
   CURSOR aCUR MESSAGE "Code"
//xx:=xx+zz
   @ xx, 30   DCSAY "SYMBOLIC CONSTANT:"  SAYSIZE 0
   @ xx, 53   DCGET MARK_ EDITPROTECT {|| lprotect } ;
   CURSOR aCUR MESSAGE "Symbolic constant"

xx:=xx+zz + zz
   @ xx, 1 DCGET ENGLISH_ ;
   CURSOR aCUR MESSAGE "Text in English"

xx:=xx+zz
   @ xx, 1 DCGET LOCALE_ ;
   CURSOR aCUR MESSAGE "Text in Locale language"

xx:=xx+zz
xx:=xx+zz

 //  of4 := Font_codepage(10,"Werdana",238,.t.)
   @ xx,1 DCMESSAGEBOX OBJECT oMsgBox SIZE 60.2,2 ;
          TEXTOBJECT MESSAGE OPTIONS XBPSTATIC_TEXT_WORDBREAK;
          COLOR GRA_CLR_DARKRED // EVAL {|o| o:setfont(of4) }

xx:=xx+zz+2


    @ xx,1 DCPUSHBUTTONXP CAPTION LNG_MSG(_OK_) OBJECT oexit;
      CURSOR aCUR ;
      SIZE 10,2.5 FONT "8.Helv Bold";
      ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)} ; // izlaz sa Esc sa prihvatanjem izmena
      MESSAGE "Potvrda izmena i izlaz"                    // zahteva:  DCGETOPTIONS NOESCAPEKEY ;







    @ xx,140-26 DCPUSHBUTTONXP CAPTION LNG_MSG(_HELP_) ;
      ACCELKEY xbeK_F1;
      CURSOR aCUR ;
      SIZE 10,2.5 FONT "8.Helv Bold";
      ACTION {||help_programa()}  ;
      MESSAGE "Uputstvo za rad taster - F1"

    @ xx,140-15 DCPUSHBUTTONXP CAPTION LNG_MSG(_EXIT_) OBJECT oexit;
      ACCELKEY xbeK_ESC;
      CURSOR aCUR ;
      SIZE 10,2.5 FONT "8.Helv Bold";
      ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)} ; // izlaz sa Esc sa prihvatanjem izmena
      MESSAGE "Izlaz - taster ESC"                        // zahteva:  DCGETOPTIONS NOESCAPEKEY ;


   DCGETOPTIONS ICON 1;
      NOESCAPEKEY NOMINBUTTON NOMAXBUTTON;
      SAYFONT "10.Verdana" GETFONT "11.Consolas Bold";
      COLORGETS { { GRA_CLR_DEFAULT, GRA_CLR_WHITE },{ GRA_CLR_DEFAULT, GraMakeRGBColor({235,232,247}) } } ;


   DCREAD GUI ;
      OPTIONS GetOptions FIT;
      TITLE LNG_MSG(_EDIT_) ;
      PARENT @oDlg ;
      EVAL {|o| SETAPPWINDOW(o)} MODAL





CLEAR TYPEAHEAD  // vraca fokus na prethodni objekat
RETURN nil


**************************************************************************
STATIC FUNCTION CH_file()
**************************************************************************
LOCAL radno:=SELECT()
* STOP("For developer only - Samo za programera",0)


LOCAL ctxt := gde_exe()+"\__LANGUAGES.CH"
DELETE FILE (ctxt)
SET PRINTER TO (ctxt)
SET PRINT ON
SET CONSOLE OFF
SET MARGIN TO 2

? "// ============"
? "// LANGUAGES.CH // START"
? "// ============"
? "// www.cobasystems.com and Alaska Xbase++ 2. and eXpress++ 2.0"
? "// * Contents of LANGUAGES.CH file that links to project "+appname()
? "// * sa programima: LANGUAGES.PRG, i __LANGUAGES.PRG"
? "// Sadraj fajla LANGUAGES.CH koji se linkuje u projekat "+appname()
? "// with programs: LANGUAGES.PRG, and __LANGUAGES.PRG"
? " "
? " "

GO TOP
DO WHILE .NOT. EOF()

   if CODE_=300
   ? " "
   ? "// APP:  "+appname()
   ? " "
   ENDIF

   ? "#define  "+MARK_+"  "+padl(CODE_,7) + "  // "+alltrim(ENGLISH_)+" // "+alltrim(LOCALE_)

SKIP
ENDDO
GO TOP
? " "
? "// "+DTOC(DATE())
? " "
? "// ============ "
? "// LANGUAGES.CH // END "
? "// ============ "

SET PRINTER TO
SET PRINT OFF
SET CONSOLE ON
SET MARGIN TO 0

RunShell(cTxt,"NOTEPAD.EXE")

SELECT(radno)
RETURN NIL


***************************************************************************
STATIC FUNCTION help_programa()
***************************************************************************
pdf:=gde_exe()+"\LANGUAGES.PDF" // or "www.cobasystems.com/help/LANGUAGES.PDF"
dc_spawnurl(pdf) // eXpres++

*
* --- text file help
private program := appname()
TEXT INTO txt WRAP

 ----------------------
 PROGRAM: &program
 ----------------------

 BUSINESS ACCOUNT TECHNOLOGY SOFTWARE (BAST)
 BAST Open Source Project &program
 COBA Systems (Serbia)
 www.cobasystems.com
 cobasystems@gmail.com
 coba@cobasystems.com


 A business application that will be used in different countries must allow
 the user of that application to translate inscriptions, titles, messages and
 other texts in the application into their local language. Such an application
 should fulfill two conditions:

 1. This translation for any user of the application should be quick and easy
    and not related to knowledge of the operating system and programming.

 2. Also, programming the application for this translation should be quick and
    easy for the application developer.

 Here I will provide one of the many possible ways to fulfill both of these
 conditions with explanations and with the source code of the application.

 -----------------

 The technique presented here is based on an excellent idea and a very good solution
 given by Roger Donnay in the eXpress++ libraries through the functions: dc_langset(),
 dc_langmsg(), dc_langblock() in the program _DCLANG.PRG, DCLIPX.LIB. I used Roger's
 code by partially simplifying it and adding a DBF file that stores a dictionary for
 the two languages ENGLISH and LOCAL and a mechanism for modifying that dictionary by
 the application user (and also by the application developer).

 In this solution, the business application has the ability to permanently store two
 dictionaries in the LANGUAGE.DBF database: a dictionary for the English language (default)
 and a dictionary for the local language. When the application starts, the file LANGUAGE.DBF
 is created automatically.

 The user of the application cannot change the dictionary for the English language.
 It can change the local language dictionary from the active application.
 It is understood that the user of the application cannot add new items to the dictionary
 and delete existing items from the dictionary. He can only write its translation in the
 local entry against the English entry.

 The application developer can change both dictionaries, can add and delete items in both
 dictionaries, and can create a text file with the source code from the file LANGUAGE.DBF
 that is embedded in the CH file of the application (which greatly reduces the work on
 coding that file).

 During the operation of the application, the user of the application can change the language
 with which the application works from only English to local and only from local to English.
 If the user of the application wants to have two different local languages (which is a rare case),
 he must create two files LANGUAGE.DBF, each file with its own local language, and change them
 in the application.

 --------------------

 This would be all about one method, out of the many existing methods,
 to work with multiple languages in one business application.

 My point of view that an application should have English as its base language,
 and as a local language only one language that the user of the application speaks
 and that the user can change, may be controversial for some. In that case,
 different solutions are possible in this technology of mine, as well as with other
 software solutions. But one thing is a fact: this is a very big and tiring job and
 few people start it without a great and justified need. Somewhere on the eXpress
 forum, Tom once said about that job: "but this is really a monkey job"
 http://bb.donnay-software.com/Donnay/viewtopic.php?f=9&t=3191&p=19366&hilit=language#p19366

 -----------------------

 08.02.2024 COBA Systems

ENDTEXT
MEMOWRIT("help.txt",txt)
RunShell("help.txt","notepad.exe")
CLEAR TYPEAHEAD
* --- text file help
*/
RETURN NIL



