//////////////////////////////////////////////////////////////////////////
//                                                                      //
//                                                                      //
//   __LANGUAGES.PRG
//                                                                      //
//   06-02-2024                                                         //
//                                                                      //
//   www.cobasystems.com --- COBA Systems --- Slobodan Stanojevi Coba  //
//   Open Source Project BAST Business Account Software Technology      //
//   www.Alaska-Software.com --- Alaska Xbase++ version 2.0.1503        //
//   www.Donnay-software.com --- eXpress++      version 2.0.268         //
//   Sergej Spirin --- FastReport for Xbase++   version 27.03.2015      //
//                                                                      //
//   Database Server PostgreSQL                 version 9.4.4.          //
//                                                                      //
//                                                                      //
//////////////////////////////////////////////////////////////////////////



/*

 Za izradu ovog programa korien je kod koji je Roger Donnay dao
 u svijim bibliotekama eXpress++ 2.0 build 268

 The code provided by Roger Donnay was used to create this program
 in all eXpress++ 2.0 build 268 libraries

 www.donnay-software.com

 ķ
   Program..: _DCLANG.PRG                           
   Author...: Roger Donnay                          
   Notice...: (c) DONNAY Software Designs 1987-2002 
   Date.....: Jan 31, 2001                          
   Notes....: Language Functions                    
                                                    
    Functions: dc_langblock(), dc_langcustom()
               dc_langset(),   dc_langmsg()

 Ľ


 FUNCTION LNG_SET() <---- dc_langset() // Roger Donnay
 FUNCTION LNG_MSG() <---- dc_langmsg() // Roger Donnay + Coba

 FUNCTION dc_langblock ( bBlock )      // Roger Donnay
 FUNCTION dc_langcustom( bBlock )      // Roger Donnay

 FUNCTION create_language_list(LNGFILE) // Coba
 FUNCTION fill_language_list(LNGFILE)   // Coba

 Za rad ovih funkcija neophodni su fajlovi:

   LANGUAGES.CH    // Coba
   LANGUAGES.DBF   // Coba



*/


* AScan( <aArray>, <bxSeekExpr>, [<nStart>], [<nCount>]) --> nElement array 1,2,3,4...n
* saLanguage := { { _WAIT_, "Wait, operation in progress" }... }
*                    a[1]          a[2]
* nFound := AScan( saLanguage, {|a|a[1]==nMessage} )






//-------------------------------------------------------------------------------
// LANGUAGES.CH
// SADRI <SYMBOLIC CONSTANTS> I NJIHOVE <RESULTS> NUMERIKE VREDNOSTI
// I ZA SVAKU APLIKACIJU JE OVAJ <LANGUAGES.CH> SA RAZLIITIM SADRAJEM.
// U NJEMU SE NE SME NITA MENJATI JER JE SVE PREKO <RESULTS> POVEZANO
// SA PODACIMA IZ FAJLA <LANGUAGES.DBF> KOJI SADRI TEKSTOVE IZ PROGRAMA
// KOJI SE MOGU PRIKAZATI U DVA JEZIKA:
//           DCLANG_ENGLISH  // engleski jezik
//           DCLANG_LOCALE   // korisnikov lokalni jezik
// TEKSTOVE ZA DCLANG_LOCALE U DBF UPISUJE I MENJA SAM KORISNIK PROGRAMA

// LANGUAGES.CH
// CONTAINS <SYMBOLIC CONSTANTS> AND THEIR <RESULTS> NUMERIC VALUES
// AND FOR EACH APPLICATION THERE IS THIS <LANGUAGES.CH> WITH DIFFERENT CONTENTS.
// NOTHING MUST BE CHANGED IN IT BECAUSE EVERYTHING IS CONNECTED THROUGH <RESULTS>
// WITH DATA FROM THE FILE <LANGUAGES.DBF> WHICH CONTAINS THE TEXTS FROM THE PROGRAM
// WHICH CAN BE DISPLAYED IN TWO LANGUAGES:
//           DCLANG_ENGLISH // English language
//           DCLANG_LOCALE // user's local language
// TEXTS FOR DCLANG_LOCALE IN DBF ARE WRITE AND CHANGED BY THE USER OF THE PROGRAM
//---------------------------------------------------------------------------------
#include "LANGUAGES.CH"

#INCLUDE "dcdialog.ch"
#INCLUDE "XBTSYS.CH"
////   #pragma Ansi2Oem(OFF)
////   #pragma Oem2Ansi(ON)


* FUNCTION LNG_MSG( nMessage )
* FUNCTION LNG_SET( applanguage, lSet, aLanguage )
* FUNCTION dc_langblock ( bBlock )
* FUNCTION dc_langcustom( bBlock )
* FUNCTION create_language_list(LNGFILE)
* STATIC FUNCTION fill_language_list(LNGFILE)


STATIC sbLangBlock := NIL,  saLanguage, sbLangCustom

*************************************************************************
FUNCTION LNG_MSG( nMessage )
*************************************************************************

LOCAL nFound, cMessage, aLanguage

******************************
IF Valtype(sbLangBlock) = 'B'
******************************
  IF Empty(saLanguage)
    ********************
    LNG_SET(applanguage) // PUBLIC applanguage = "ENG" or "LOC"
    ********************
  ENDIF

  nFound := AScan( saLanguage, {|a|a[1]==nMessage} )
  IF nFound > 0

    // STOP(1,nMessage,saLanguage[5],nFound,1)  // ---- test
    cMessage := saLanguage[nFound,2]

  ELSE
    cMessage := ""
    // STOP(1,"NOT FOUND ",nMessage,1) // ---- test
  ENDIF

  cMessage := Eval(sbLangBlock,cMessage,nMessage)

  RETURN cMessage

*****************************
ELSEIF Empty(saLanguage)
*****************************
  LNG_SET(applanguage) // PUBLIC applanguage = "ENG" or "LOC"
*****************************
ENDIF
*****************************

IF Valtype( nMessage ) # 'N'
  RETURN ""  // VRATI TEKST PORUKE KAO PRAZAN STRING
ENDIF




//*************** ako je sve u redu ******************

nFound := AScan( saLanguage, {|a|a[1]==nMessage} )
IF nFound > 0
  //STOP(2,nMessage,saLanguage[nMessage],nFound,1) // ----------------------------- test

  RETURN saLanguage[nFound,2]   // VRATI TEKST PORUKE
ELSE
  //STOP(2,"NOT FOUND ",nMessage,1)  // NIJE NAENO - NASTAVI DALJE
ENDIF

// AKO NIJE NAEN TRAENI KOD JEZIK SE POSTAVLJA NA ENGLESKI
// JER SE SMATRA DA U TOM DEFAULT JEZIKU TAJ KOD MORA DA POSTOJI
// PA SE PONOVO TRAI TAJ KOD
************************************
LNG_SET(applanguage,.f.,@aLanguage) // PUBLIC applanguage = "ENG" or "LOC"
************************************
nFound := AScan( aLanguage, {|a|a[1]==nMessage} )

IF nFound > 0

  // STOP(3,nMessage,saLanguage[5],nFound,1) // ----------------------------- test
  RETURN aLanguage[nFound,2]   // VRATI TEKST PORUKE

ELSE
  // STOP(3,"NOT FOUND "+nMessage,1)
ENDIF

// AKO SE I SADA U ENGLESKOM JEZIKU NE PRONAE ZADATI KOD
// FUNKCIJA KAO TEKST PORUKE VRAA PRAZAN STRING
RETURN ""



*************************************************************************
FUNCTION LNG_SET( applanguage, lSet, aLanguage )
*************************************************************************
// PUBLIC snLanguage := applanguage // "ENG" or "LOC"
LOCAL nOldLanguage := snLanguage    // "ENG" or "LOC"
LOCAL xcod, xeng, xloc

DEFAULT lSet := .t.

IF Valtype(applanguage) # 'C'
   RETURN snLanguage
ELSEIF lSet
   snLanguage := applanguage // nLanguage
ENDIF


* --- Coba izmene - Coba changes --- start

SET CHARSET TO ANSI
PRIVATE radno:=SELECT()

* -----
* gde_exe() -> strtran( appname(.t.),"\"+appname() )
DIRMAKE( gde_exe()+"\DBF")  // XbToolsIII++
LNGFILE := gde_exe()+"\DBF\LANGUAGES.DBF"
IF FILE(LNGFILE)==.f.
  *******************************
   create_language_list(LNGFILE)   // Here
  *******************************
ENDIF
* -----

// Preuzimanje podataka iz LANGUAGES.DBF u array aLANGUAGE
// Download data from LANGUAGES.DBF to array aLANGUAGE
USE (LNGFILE) NEW SHARED ALIAS "LNG" VIA "DBFNTX"
* VIA "DBFNTX" = je obavezno kada se radi sa DbeSetDefault("PGDBE")
* VIA "DBFNTX" = is required when working with DbeSetDefault("PGDBE")

      IF NetErr()
         SELECT(radno)
         MsgBox(LNGFILE+chr(13)+LNG_MSG(_NETWORK_),"Stop")
         RETURN .F.
      ENDIF

// formiraj array iz dbf podataka: numerik code  + string text ENGLISH_ i LOCALE_
// form array from dbf data: numeric code + string text ENGLISH_ and LOCALE_
******************
 aLanguage := {}
******************
* ako aLanguage nije postavljeno na aLanguage := {}
* dolazi do greke: Erroir BASE 10/25
*                   Description: Parameter has a wrong data type
*                   Operation: aAdd
GO TOP
DO WHILE .NOT. EOF()


    xcod:=LNG->CODE_
    xeng:=alltrim(LNG->ENGLISH_)
    xloc:=alltrim(LNG->LOCALE_)

      *---test
      *stop( xcod, TYPE("xcod"),;
      *      xeng, TYPE("xeng"),;
      *      xloc, TYPE("xloc"),;
      *      1)
      *---test

 // IF nLanguage = 1
  IF applanguage = "ENG"
     AAdd( aLanguage, { xcod, xeng }) // , LNG->MARK_,  } )
  ELSE
     AAdd( aLanguage, { xcod, xloc }) // , LNG->MARK_,  } )
  ENDIF

SKIP
ENDDO
SELECT "LNG";USE
SELECT(radno)

*--- test
* xx:=""
* for i=1 to len(aLanguage)
*    xx:=xx+var2char(aLanguage[i])+chr(13)+chr(10)
* next i
* dc_memoedit(xx)
* dc_arrayview(aLanguage)
* --- test

* --- Coba izmene - Coba changes --- end



    ***********************************
    IF lSet
      saLanguage := AClone(aLanguage)    // copy aLanguage to saLanguage
    ENDIF
    ***********************************



RETURN nOldLanguage



*************************************************************************
FUNCTION dc_langblock ( bBlock )
*************************************************************************
LOCAL bOldBlock := sbLangBlock

IF Valtype(bBlock) = 'B'
  sbLangBlock := bBlock
ENDIF

RETURN bOldBlock

*************************************************************************
FUNCTION dc_langcustom( bBlock )
*************************************************************************
LOCAL bOldBlock := sbLangCustom

IF Valtype(bBlock) = 'B'
  sbLangCustom := bBlock
ENDIF

RETURN bOldBlock




* Coba:
* FUNCTION create_language_list(LNGFILE)
* FUNCTION fill_language_list(LNGFILE)

*************************************************************************
FUNCTION create_language_list(LNGFILE)
*************************************************************************
* gde_exe() -> strtran( appname(.t.),"\"+appname() )
* DIRMAKE( gde_exe()+"\DBF")
* LNGFILE := gde_exe()+"\DBF\LANGUAGES.DBF"

LOCAL radno:=SELECT(), aStructure := {}
SELECT 0
      aStructure := { ;
              { "CODE_"         , "N",   7, 0 }, ;
              { "MARK_"         , "C",  30, 0 }, ;
              { "ENGLISH_"      , "C", 120, 0 }, ;
              { "LOCALE_"       , "C", 120, 0 }  ;
            }
      DbCreate( LNGFILE, aStructure, "DBFNTX" )
      USE (LNGFILE) NEW SHARED ALIAS "LNG"
      nCount:=reccount()
      SELECT "LNG";USE

      IF RECCOUNT()=0
         ***************************
         fill_language_list(LNGFILE)
         ***************************
      ENDIF


SELECT(radno)
RETURN NIL


**************************************************************************
STATIC FUNCTION fill_language_list(LNGFILE)
**************************************************************************
* gde_exe() -> strtran( appname(.t.),"\"+appname() )
* DIRMAKE( gde_exe()+"\DBF")
* LNGFILE := gde_exe()+"\DBF\LANGUAGES.DBF"

LOCAL radno:=SELECT()

      USE (LNGFILE) NEW SHARED ALIAS "LNG" VIA "DBFNTX"
     * VIA "DBFNTX" = je obavezno kada se radi sa DbeSetDefault("PGDBE")
     * VIA "DBFNTX" = is required when working with DbeSetDefault("PGDBE")
      IF NetErr()
         MsgBox(LNGFILE+chr(13)+LNG_MSG(_NETWORK_),"Stop")
         RETURN .F.
      ENDIF

* Ovde polje MARK_ sadri naziv numerike varijable kao string,
* Ovaj string naziv slui samo za bolje snalaenje - kako bi se korisnik
* snaao kod popunjavanja dbf liste poruka. Recno() je redni broj poruke
* odnosno redni broj lana array niza koji se dobija iz ove dbf
*
* Polje CODE_ sadri numeriki kod poruke a polje TEXT_ sadri tekst poruke
* i ova sva polja se prebacuju u array niz koji se koristi od strane aplikacije
* za prevoenje teksta na zadati jezik
* ---
* Here the field MARK_ contains the name of the numeric variable as a string,
* This string name is only for better navigation - so that the user
* figured out how to populate the dbf message list. Line() is the sequence number of the message
* that is, the sequence number of the member of the array string that is obtained from this dbf
*
* The field CODE_ contains the numerical code of the message and the field TEXT_ contains the text of the message
* and all these fields are transferred to an array used by the application
* to translate the text into the given language

**************************************************
// SEKCIJA A:
// ----------
// Osnovne SIMBOLIKE KONSTANTE i njihov RESULT COD (numerika vrednost)
// koje se koriste u svakoj poslovnoj CSYSTEMS aplikaciji:
//
// Basic SYMBOLIC CONSTANTS and their RESULT COD (numeric value)
// which are used in every business CSYSTEMS application:

APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_OK_",            ENGLISH_ WITH "OK"                                   , LOCALE_ WITH "OK"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_CANCEL_",        ENGLISH_ WITH "Cancel"                               , LOCALE_ WITH "Odustani"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_ABORT_",         ENGLISH_ WITH "Abort"                                , LOCALE_ WITH "Prekini"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_HELP_",          ENGLISH_ WITH "Help"                                 , LOCALE_ WITH "Pomo"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_WAIT_",          ENGLISH_ WITH "Wait, operation is in progress..."    , LOCALE_ WITH "Saekaj operacija u toku..."
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_YES_",           ENGLISH_ WITH "Yes"                                  , LOCALE_ WITH "Da"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_NO_",            ENGLISH_ WITH "No"                                   , LOCALE_ WITH "Ne"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_EXIT_",          ENGLISH_ WITH "Exit"                                 , LOCALE_ WITH "Izlaz"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_PRINT_",         ENGLISH_ WITH "Print"                                , LOCALE_ WITH "tampaj"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_EXECUTE_",       ENGLISH_ WITH "Execute"                              , LOCALE_ WITH "Izvri"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_RESULTS_",       ENGLISH_ WITH "Results"                              , LOCALE_ WITH "Rezultat"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_USER_",          ENGLISH_ WITH "User"                                 , LOCALE_ WITH "Korisnik"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_PASSWORD_",      ENGLISH_ WITH "Password"                             , LOCALE_ WITH "Lozinka"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_CREATE_",        ENGLISH_ WITH "Create"                               , LOCALE_ WITH "Kreiraj"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_NEW_",           ENGLISH_ WITH "New"                                  , LOCALE_ WITH "Novo"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_DEL_",           ENGLISH_ WITH "Del"                                  , LOCALE_ WITH "Brii"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_SAVE_",          ENGLISH_ WITH "Save"                                 , LOCALE_ WITH "Sauvaj"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_EDIT_",          ENGLISH_ WITH "Edit"                                 , LOCALE_ WITH "Izmeni"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_FINDNAME_",      ENGLISH_ WITH "Find name"                            , LOCALE_ WITH "Nai naziv"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_FINDCODE_",      ENGLISH_ WITH "Find code"                            , LOCALE_ WITH "Nai kod"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_FINDTEXT_",      ENGLISH_ WITH "Text to find"                         , LOCALE_ WITH "Nai tekst"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_FINDDATE_",      ENGLISH_ WITH "Find date"                            , LOCALE_ WITH "Nai datum"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_FINDCATALOG_",   ENGLISH_ WITH "Find catalog"                         , LOCALE_ WITH "Nai katalog"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_FINDBARCODE_",   ENGLISH_ WITH "Find barcode"                         , LOCALE_ WITH "Nai barkod"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_FINDLINK_",      ENGLISH_ WITH "Find link"                            , LOCALE_ WITH "Nai vezu"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_FINDMARK_",      ENGLISH_ WITH "find mark"                            , LOCALE_ WITH "Nai oznaku"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_FINDNUMBER_",    ENGLISH_ WITH "Find number"                          , LOCALE_ WITH "Nai broj"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_NOTFOUND_",      ENGLISH_ WITH "Not found"                            , LOCALE_ WITH "Nije naeno"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_FOUND_",         ENGLISH_ WITH "Found"                                , LOCALE_ WITH "Naeno je"
**************************************************

APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_DAY_", ENGLISH_ WITH "Day", LOCALE_ WITH "Dan"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_WEEK_", ENGLISH_ WITH "Week", LOCALE_ WITH "Nedelja"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_MONTH_", ENGLISH_ WITH "Month", LOCALE_ WITH "Mesec"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_YEAR_", ENGLISH_ WITH "Year", LOCALE_ WITH "Godina"

APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_MONTH1_", ENGLISH_ WITH "January", LOCALE_ WITH "Januar"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_MONTH2_", ENGLISH_ WITH "February", LOCALE_ WITH "Februar"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_MONTH3_", ENGLISH_ WITH "March", LOCALE_ WITH "Mart"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_MONTH4_", ENGLISH_ WITH "April", LOCALE_ WITH "April"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_MONTH5_", ENGLISH_ WITH "May", LOCALE_ WITH "Maj"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_MONTH6_", ENGLISH_ WITH "June", LOCALE_ WITH "Juni"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_MONTH7_", ENGLISH_ WITH "July", LOCALE_ WITH "Juli"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_MONTH8_", ENGLISH_ WITH "August", LOCALE_ WITH "Avgust"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_MONTH9_", ENGLISH_ WITH "September", LOCALE_ WITH "Septembar"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_MONTH10_", ENGLISH_ WITH "October", LOCALE_ WITH "Oktobar"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_MONTH11_", ENGLISH_ WITH "November", LOCALE_ WITH "Novembar"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_MONTH12_", ENGLISH_ WITH "December", LOCALE_ WITH "Decembar"

APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_DAY1_", ENGLISH_ WITH "Sunday", LOCALE_ WITH "Nedelja"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_DAY2_", ENGLISH_ WITH "Monday", LOCALE_ WITH "Ponedeljak"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_DAY3_", ENGLISH_ WITH "Tuesday", LOCALE_ WITH "Utorak"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_DAY4_", ENGLISH_ WITH "Wednesday", LOCALE_ WITH "Sreda"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_DAY5_", ENGLISH_ WITH "Thursday", LOCALE_ WITH "Cetvrtak"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_DAY6_", ENGLISH_ WITH "Friday", LOCALE_ WITH "Petak"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_DAY7_", ENGLISH_ WITH "Saturday", LOCALE_ WITH "Subota"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_toDAY_", ENGLISH_ WITH "Today", LOCALE_ WITH "Danas"

APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_DIRYES_", ENGLISH_ WITH "Choose a Directory", LOCALE_ WITH "Izaberi direktorijum-folder"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_DIRNO_", ENGLISH_ WITH "Invalid Drive or Directory", LOCALE_ WITH "Nema drajva ili direktorija"

APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_FILENAME_", ENGLISH_ WITH "File name", LOCALE_ WITH "Naziv fajla"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_FILEYES_", ENGLISH_ WITH "File exists", LOCALE_ WITH "Fajl postoji"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_FILENO_", ENGLISH_ WITH "File not exists", LOCALE_ WITH "Fajl ne postoji"

APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_DBYES_", ENGLISH_ WITH "Database exists", LOCALE_ WITH "Databaza postoji"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_DBNO_", ENGLISH_ WITH "Database not exists", LOCALE_ WITH "Databaza ne postoji"

APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_CALC_", ENGLISH_ WITH "Calculator", LOCALE_ WITH "Kalkulator"

APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_RANGE_", ENGLISH_ WITH "Valid Range is", LOCALE_ WITH "Dozvoljeni rang je"

APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_DESCRIPT_", ENGLISH_ WITH "Description", LOCALE_ WITH "Opis"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_WORKING_", ENGLISH_ WITH "Working", LOCALE_ WITH "U radu"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_PLEASEWAIT_", ENGLISH_ WITH "Please wait", LOCALE_ WITH "Molim saekajte"

APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_NETWORK_", ENGLISH_ WITH "Busy network", LOCALE_ WITH "Zauzeto u mrei"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_ERROR_", ENGLISH_ WITH "Error", LOCALE_ WITH "Greka"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_CHOOSE_", ENGLISH_ WITH "Choose", LOCALE_ WITH "Izaberi"

APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_DOCYES_", ENGLISH_ WITH "Document exists", LOCALE_ WITH "Dokument postoji"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_DOCNO_", ENGLISH_ WITH "Document not exists", LOCALE_ WITH "Dokument ne postoji"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_EXISTYES_", ENGLISH_ WITH "Exists", LOCALE_ WITH "Postoji"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_EXISTNO_", ENGLISH_ WITH "Not exists", LOCALE_ WITH "Ne postoji"

APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_START_", ENGLISH_ WITH "Start", LOCALE_ WITH "Poetak"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_END_", ENGLISH_ WITH "End", LOCALE_ WITH "Kraj"

APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_LOCALE_", ENGLISH_ WITH "Set language to locale", LOCALE_ WITH "Postavi jezik na lokalni"
APPEND BLANK ;  REPLACE CODE_ WITH recno() , MARK_ WITH "_ENGLISH_", ENGLISH_ WITH "Set language to english", LOCALE_ WITH "Postavi jezik na engleski"

**************************************************
// SEKCIJA B:
// ----------
// Osnovne SIMBOLIKE KONSTANTE i njihov RESULT COD (numerika vrednost)
// koje se koriste samo u ovoj poslovnoj CSYSTEMS aplikaciji:
//
// Basic SYMBOLIC CONSTANTS and their RESULT COD (numeric value)
// which are only used in this business CSYSTEMS application:

APPEND BLANK ;  REPLACE CODE_ WITH 300 , MARK_ WITH "_APPNAME_", ;
ENGLISH_ WITH "LANGUAGE SETTING :: ENGLISH and LOCALE" ,;
LOCALE_  WITH "POSTAVKA JEZIKA :: ENGLESKI i LOKALNI"

APPEND BLANK ;  REPLACE CODE_ WITH 301 , MARK_ WITH "_ENG_",;
ENGLISH_ WITH "ENGLISH",;
LOCALE_  WITH "ENGLESKI"

APPEND BLANK ;  REPLACE CODE_ WITH 302 , MARK_ WITH "_LOC_",;
ENGLISH_ WITH "LOCALE" ,;
LOCALE_  WITH "LOKALNI"
***************************************************


COMMIT
SELECT "LNG";USE
SELECT(radno)
RETURN .T.






/*
// START --- Fajl: LANGUAGES.CH
//
//
//-------------------------------------------------------------------------------
// LANGUAGES.CH
// SADRI <SYMBOLIC CONSTANTS> I NJIHOVE <RESULTS> NUMERIKE VREDNOSTI
// I ZA SVAKU APLIKACIJU JE OVAJ <LANGUAGES.CH> SA RAZLIITIM SADRAJEM.
// U NJEMU SE NE SME NITA MENJATI JER JE SVE PREKO <RESULTS> POVEZANO
// SA PODACIMA IZ FAJLA <LANGUAGES.DBF> KOJI SADRI TEKSTOVE IZ PROGRAMA
// KOJI SE MOGU PRIKAZATI U DVA JEZIKA:
//           DCLANG_ENGLISH  // engleski jezik
//           DCLANG_LOCALE   // korisnikov lokalni jezik
// TEKSTOVE ZA DCLANG_LOCALE U DBF UPISUJE I MENJA SAM KORISNIK PROGRAMA

// LANGUAGES.CH
// CONTAINS <SYMBOLIC CONSTANTS> AND THEIR <RESULTS> NUMERIC VALUES
// AND FOR EACH APPLICATION THERE IS THIS <LANGUAGES.CH> WITH DIFFERENT CONTENTS.
// NOTHING MUST BE CHANGED IN IT BECAUSE EVERYTHING IS CONNECTED THROUGH <RESULTS>
// WITH DATA FROM THE FILE <LANGUAGES.DBF> WHICH CONTAINS THE TEXTS FROM THE PROGRAM
// WHICH CAN BE DISPLAYED IN TWO LANGUAGES:
//           DCLANG_ENGLISH // English language
//           DCLANG_LOCALE // user's local language
// TEXTS FOR DCLANG_LOCALE IN DBF ARE WRITE AND CHANGED BY THE USER OF THE PROGRAM
//---------------------------------------------------------------------------------
//
// Example:
// <SymbolicConstant>    _OK_  je ime za simboliku konstantu.
// <ResultCode>     1    definie znakove kojima pretprocesor zamjenjuje one znakove
//                       koji odgovaraju onome to je sadrano u <SymbolicConstant>.
//                       <ResultCode> je opcioni.









// LANGUAGE:
// ---------
#define DCLANG_ENGLISH  1
#define DCLANG_LOCALE   2


// SEKCIJA A:
// ----------
// Osnovne SIMBOLIKE KONSTANTE i njihov RESULT COD (numerika vrednost)
// koje se koriste u svakoj poslovnoj CSYSTEMS aplikaciji:
// Basic SYMBOLIC CONSTANTS and their RESULT COD (numeric value)
// which are used in every business CSYSTEMS application:

#define  _OK_           1  // Ok
#define  _CANCEL_       2  // Cancel
#define  _ABORT_        3  // Abort
#define  _HELP_         4  // Help
#define  _WAIT_         5  // Wait
#define  _YES_          6  // Yes
#define  _NO_           7  // No
#define  _EXIT_         8  // Exit
#define  _PRINT_        9  // Print
#define  _EXECUTE_     10  // Execute
#define  _RESULTS_     11  // Results
#define  _USER_        12  // User
#define  _PASSWORD_    13  // Password
#define  _CREATE_      14  // Create
#define  _NEW_         15  // New
#define  _DEL_         16  // Del
#define  _SAVE_        17  // Save
#define  _EDIT_        18  // Edit

#define  _FINDNAME_    19  // Find name
#define  _FINDCODE_    20  // Find code
#define  _FINDTEXT_    21  // Text to find
#define  _FINDDATE_    22  // Find date
#define  _FINDCATALOG_ 23  // Find catalog
#define  _FINDBARCODE_ 24  // Find barcode
#define  _FINDLINK_    25  // Find link
#define  _FINDMARK_    26  // Find mark
#define  _FINDNUMBER_  27  // Find number
#define  _NOTFOUND_    28  // Not Found
#define  _FOUND_       29  // Found

#define  _DAY_         30  //  "Day"
#define  _WEEK_        31  //  "Week"
#define  _MONTH_       32  //  "Month"
#define  _YEAR_        33  //  "Year"

#define  _MONTH1_      34  //  "January"    "Januar"
#define  _MONTH2_      35  //  "February"   "Februar"
#define  _MONTH3_      36  //  "March"      "Mart"
#define  _MONTH4_      37  //  "April"      "April"
#define  _MONTH5_      38  //  "May"        "Maj"
#define  _MONTH6_      39  //  "June"       "Juni"
#define  _MONTH7_      40  //  "July"       "Juli"
#define  _MONTH8_      41  //  "August"     "Avgust"
#define  _MONTH9_      42  //  "September"  "Septembar"
#define  _MONTH10_     43  //  "October"    "Oktobar"
#define  _MONTH11_     44  //  "November"   "Novembar"
#define  _MONTH12_     45  //  "December"   "Decembar"

#define  _DAY1_       46  //  "Sunday"      "Nedelja"
#define  _DAY2_       47  //  "Monday"      "Ponedeljak"
#define  _DAY3_       48  //  "Tuesday"     "Utorak"
#define  _DAY4_       49  //  "Wednesday"   "Sreda"
#define  _DAY5_       50  //  "Thursday"    "Cetvrtak"
#define  _DAY6_       51  //  "Friday"      "Petak"
#define  _DAY7_       52  //  "Saturday"    "Subota"
#define  _TODAY_      53  //  "Today"       "Danas"

#define  _DIRYES_     54  //  "Choose a Directory"          "Izaberi direktorijum-folder"
#define  _DIRNO_      55  //  "Invalid Drive or Directory"  "Nema drajva ili direktorija"
#define  _FILENAME_   56  //  "File Name"                   "Naziv fajla"
#define  _FILEYES_    57  //  "File exists"                 "Fajl postoji"
#define  _FILENO_     58  //  "File not exists"             "Fajl ne postoji"
#define  _DBYES_      59  //  "Databse exists"              "Databaza postoji"
#define  _DBNO_       60  //  "Databse not exists"          "Databaza ne postiji"

#define  _CALC_       61  //  "Calculator"      "Kalkulator"
#define  _RANGE_      62  //  "Valid Range is"  "Dozvoljeni rang je"
#define  _DESCRIPT_   63  //  "Description"     "Opis"
#define  _WORKING_    64  //  "Working"         "Radi"
#define  _PLEASEWAIT  65  //  "Please wait"     "Molim Saekajte"

#define  _NETWORK_    66  // "Busy network"     "Zauzeto u mrei"
#define  _ERROR_      67  // "Error"            "Greka"
#define  _CHOOSE_     68  // "Choose"           "Izaberi"

#define  _DOCYES_     69  // "Document exists"      "Dokument postoji"
#define  _DOCNO_      70  // "Document not exists"  "Dokument ne postoji"
#define  _EXISTYES_   71  // "Exists"               "Postoji"
#define  _EXISTNO_    72  // "Not exists"           "Ne postoji"




// SEKCIJA B:
// ----------
// Osnovne SIMBOLIKE KONSTANTE i njihov RESULT COD (numerika vrednost)
// koje se koriste samo u ovoj poslovnoj CSYSTEMS aplikaciji:
// Basic SYMBOLIC CONSTANTS and their RESULT COD (numeric value)
// which are only used in this business CSYSTEMS application:

#define  _APPNAME_    300  //  "LANGUAGE SETTING :: ENGLISH and LOCALE" "POSTAVKA JEZIKA :: ENGLEDKI i LOKALNI"
#define  _ENG_        301  //  "ENGLISH" "ENGLESKI"
#define  _LOC_        302  //  "LOCALE" "LOKALNI"


// END --- Fajl: LANGUAGES.CH
*/
